* Version 3.1
LPARAMETERS lcFileName,lnStartRows,lnTable,lcTrue,lcFalse,llCursor,lnHeader
* lcFileName		name of the docx
					* nom de docx
					* numele docx-ului
* lnStartRows		starting row (the first lnStartRows - 1 rows are skipped) ; optional ; default 1 (all rows)
					* a partir range (les premiers lnStartRows - 1 lignes sont passes) ; optionnel ; dfaut 1 (tous les champs lignes)
					* primul rand (primele lnStartRows - 1 randuri ale tabelului din docx sunt omise); optional; implicit 1 (toate randurile)
* lnTable			table# ; optional ; default 1
					* table# ; optionnel ; dfaut 1
					* tabel# ; optional ; implicit 1 (al catelea tabel din docx)
* lcTrue			the text representing "true" for boolean fields ; optional ; default "true"
					* le texte reprsentant "true" pour les champs boolens; optionnel; dfaut "true"
					* textul prin care e reprezentat "true", pentru campurile booleene; optional; implicit "true"
* lcFalse			the text representing "false" for boolean fields ; optional ; default "false"
					* le texte reprsentant "false" pour les champs boolens; optionnel; dfaut "false"
					* textul prin care e reprezentat "false", pentru campurile booleene; optional; implicit "false"
* llCursor			when .T., the result is a cursor instead of a DBF ; optional ; default .F.
					* lorsque .T, le rsultat est un cursor au lieu d'un DBF; optionnel; dfaut .F.
					* cand este .T., rezultatul este un cursor si nu un DBF; optional; implicit .F.
* lnHeader			the row that contains column headers (lnHeader < lnStartRows); optional ; default 0
					* nombre de la ligne d'en-tte (lnHeader < lnStartRows); optionnel ; dfaut 0
					* linia care contine antetele coloanelor (lnHeader < lnStartRows); optional; implicit 0
DECLARE Sleep IN WIN32API INTEGER 
#DEFINE ERRLANG "En"
#IF ERRLANG = "Ro"
	#DEFINE ERRMESS0 "Eroare"
	#DEFINE ERRMESS1 "Nimic de importat"
	#DEFINE ERRMESS3 "Tabel inexistent"
	#DEFINE ERRMESS4 "Eroare la deschiderea"
#ELIF ERRLANG = "Fr"
	#DEFINE ERRMESS0 "Erreur"
	#DEFINE ERRMESS1 "Rien a ajouter"
	#DEFINE ERRMESS3 "Tableau introuvable"
	#DEFINE ERRMESS4 "Erreur d'ouverture"
#ELIF ERRLANG = "Nl" && Koen Piller
	#DEFINE ERRMESS0 "Fout"
	#DEFINE ERRMESS1 "Niets te importeren"
	#DEFINE ERRMESS3 "Tabel nietb gevonden"
	#DEFINE ERRMESS4 "Fout bij openen"
#ELSE
	#DEFINE ERRMESS0 "Error"
	#DEFINE ERRMESS1 "Nothing to append"
	#DEFINE ERRMESS3 "Table not found"
	#DEFINE ERRMESS4 "Error opening"
#ENDIF

LOCAL lcDir,lSetTalk,lnFFields,laFFields[1],lnColsNoAll,laFieldsAll[1],lnColsNo,laFields[1,18],lnCurCol,llMemos,lnSelect,lcCur,lcDBF
lnSelect = SELECT(0)

IF PCOUNT() < 1 
	MESSAGEBOX(ERRMESS1,16,ERRMESS0)
	RETURN
ELSE
	IF VARTYPE(m.lcFileName) $ "CV"
		lcFileName = FORCEEXT(m.lcFileName,"docx")
		IF !FILE(m.lcFileName)
			MESSAGEBOX(ERRMESS1,16,ERRMESS0)
			RETURN
		ENDIF
	ELSE
		MESSAGEBOX(ERRMESS1,16,ERRMESS0)
		RETURN
	ENDIF
ENDIF
IF PCOUNT() < 2
	lnStartRows = 1
ELSE
	IF VARTYPE(m.lnStartRows) <> "N"
		lnStartRows = 1
	ENDIF
ENDIF
IF PCOUNT()<3
	lnTable = 1
ELSE
	IF VARTYPE(m.lnTable) <> "N"
		lnTable = 1
	ENDIF
ENDIF
IF PCOUNT()<4
	lcTrue = "true"
ELSE
	IF VARTYPE(m.lcTrue) <> "C"
		lcTrue = "true"
	ELSE
		lcTrue = LOWER(m.lcTrue)
	ENDIF
ENDIF
IF PCOUNT()<5
	lcFalse = "false"
ELSE
	IF VARTYPE(m.lcFalse) <> "C"
		lcFalse = "false"
	ELSE
		lcFalse = LOWER(m.lcFalse)
	ENDIF
ENDIF
IF PCOUNT() < 6
	llCursor = .F.
ELSE
	IF VARTYPE(m.llCursor) <> "L"
		llCursor = .F.
	ENDIF
ENDIF
IF PCOUNT() < 7
	lnHeader = 0
ELSE
	IF VARTYPE(m.lnHeader) <> "N"
		lnHeader = 0
	ENDIF
ENDIF
IF m.lnHeader >= m.lnStartRows
	lnHeader = 0
ENDIF

lSetTalk = SET("Talk")
SET TALK OFF 

lcDir = extract(m.lcFileName)
lcDBF = ""

lcCur = gen_table(ADDBS(m.lcDir) + "document.xml",m.lnStartRows,m.lnTable,@lnColsNo,@laFields,m.lcTrue,m.lcFalse,m.lnHeader,m.llCursor)
IF EMPTY(m.lcCur)
	SET TALK &lSetTalk
	SELECT (m.lnSelect)
	RETURN m.lcDBF
ENDIF
lcDBF = get_cells(ADDBS(m.lcDir) + "document.xml",m.lnStartRows,m.lnTable,lnColsNo,@laFields,m.lcCur,m.lcFileName,m.lcTrue,m.lcFalse,m.llCursor)
cleanup(m.lcDir)
IF USED(m.lcCur)
	USE IN (m.lcCur)
ENDIF
SET TALK &lSetTalk
SELECT (m.lnSelect)
RETURN m.lcDBF

*********************
* Extract xml files *
*********************
FUNCTION extract
	LPARAMETERS lcFileName
	LOCAL lcDir,lcZip,oShell,ofile,loErr as Exception,lcSetSaf,lni,lnFF
	lcDir = ADDBS(SYS(2023)) + SYS(2015)
	lcZip = FORCEEXT(m.lcDir,'.zip')
	COPY FILE (m.lcFileName) TO (m.lcZip)
	MD (m.lcDir)
	oShell = CREATEOBJECT("shell.application")
	TRY
		FOR lni = 0 TO m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.count - 1
			ofile = m.oShell.NameSpace(ADDBS(m.lcZip)+'word').items.item(m.lni)
			IF m.ofile.name == 'document.xml'
				oShell.NameSpace( m.lcDir).copyhere( m.ofile)
				lnFF = FOPEN(ADDBS(lcDir) + m.ofile.name)
				DO WHILE m.lnFF < 0
					sleep(50)
					lnFF = FOPEN(m.ofile.name)
				ENDDO
				FCLOSE(m.lnFF)
			ENDIF
		ENDFOR
	CATCH TO loErr
	ENDTRY
RETURN lcDir
	

**********************************************
* Read first row and determine the data type *
**********************************************
FUNCTION gen_table
	LPARAMETERS lcStr,lnStartRows,lnTable,lnField,laFieldGat,lcTrue,lcFalse,lnHeader,llCursor
	LOCAL lcSetDec,lnCurRow,lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal,lcPoint,llNumber,llDate,llTime,llBool,lcTable,lcTextPiece,lnPar,lcPar,lcWholeWal,lnName,lcName
	LOCAL lnLeftName,lnFieldF,lnSpan,lcSpan,lnFieldExtr
	lcTable = SYS(2015)
	lcPoint = SET("Point")

	lcWholeDoc = FILETOSTR(m.lcStr)
	lnNoOfTables = OCCURS("<w:tbl>",m.lcWholeDoc)
	IF m.lnNoOfTables < m.lnTable
		MESSAGEBOX(ERRMESS3,16,ERRMESS0)
		RETURN ''
	ENDIF
	lcWholeTable = STREXTRACT(m.lcWholeDoc,"<w:tbl>","</w:tbl>",m.lnTable)
	lnFieldF = 0
		
	**************
	IF m.lnHeader > 0
		lnCurRow = m.lnHeader
		lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr ","</w:tr>",m.lnCurRow)
		IF EMPTY(m.lcWholeRow)
			RETURN ''
		ENDIF
		lnFieldF = 1
		lnFieldExtr = 1
		lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lnFieldExtr)
		DO WHILE !EMPTY(m.lcCell)
			lnSpan = 0
			lcSpan = STREXTRACT(m.lcCell,[w:gridSpan w:val="],["])
			IF !EMPTY(m.lcSpan)
				lnSpan = VAL(m.lcSpan) - 1
			ENDIF
			DIMENSION laFieldGat[m.lnFieldF + m.lnSpan,18]
			FOR lni = m.lnFieldF TO m.lnFieldF + m.lnSpan
				STORE 0 TO laFieldGat[m.lni,17],laFieldGat[m.lni,18],laFieldGat[m.lni,4]
				STORE .T. TO laFieldGat[m.lni,5]
				STORE .F. TO laFieldGat[m.lni,6],laFieldGat[m.lni,5]
				STORE '' TO laFieldGat[m.lni,7],laFieldGat[m.lni,8],laFieldGat[m.lni,9],laFieldGat[m.lni,10],laFieldGat[m.lni,11],laFieldGat[m.lni,12],laFieldGat[m.lni,13],laFieldGat[m.lni,14],laFieldGat[m.lni,15],laFieldGat[m.lni,16]
				laFieldGat[m.lni,1] = "MFIELD"+TRANSFORM(m.lni)
			NEXT
			lnFieldF = lnFieldF + m.lnSpan

			lnPar = 1
			lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>])
			lcWholeWal = ""
			DO WHILE !EMPTY(m.lcPar)
				lcPar = STREXTRACT(m.lcPar,[>])
				lnPar = m.lnPar + 1
				
				lnTextPiece = 1
				lcVal = ""
				lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>]) 
				DO WHILE !EMPTY(m.lcTextPiece)
					lnTextPiece = m.lnTextPiece + 1
					IF INLIST(LEFT(m.lcTextPiece,1),' ','>')
						lcVal = m.lcVal + STREXTRACT(m.lcTextPiece,'>')
					ENDIF
					lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>],m.lnTextPiece) 
				ENDDO
				lcWholeWal = m.lcWholeWal + IIF(EMPTY(m.lcWholeWal),"",CHR(13)+CHR(10)) + m.lcVal
				lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>],m.lnPar)
			ENDDO
			llNumber = !EMPTY(m.lcWholeWal) and EMPTY(CHRTRAN(m.lcWholeWal,"0123456789+-" + m.lcPoint,"")) and ;
						OCCURS(m.lcPoint,m.lcWholeWal) < 2 and ;
						OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) < 2 and ;
						IIF(OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) > 0, LEFT(LTRIM(m.lcWholeWal),1) $ "+-", .T.) ;
						and AT(CHR(13),m.lcWholeWal) = 0
			llDate = !EMPTY(CTOD(m.lcWholeWal))
			llTime = !llDate and !EMPTY(CTOT(m.lcWholeWal))
			llBool = INLIST(LOWER(ALLTRIM(m.lcWholeWal)),m.lcTrue,m.lcFalse)
			DO CASE
			CASE m.llNumber
				laFieldGat[m.lnFieldF,1] = "_" + CHRTRAN(m.lcWholeWal,'.,+-','')
			CASE m.llDate
				laFieldGat[m.lnFieldF,1] = "_" + DTOS(CTOD(m.lcWholeWal))
			CASE m.llTime
				laFieldGat[m.lnFieldF,1] = "_" + TTOC(CTOT(m.lcWholeWal),1)
			CASE m.llBool
				laFieldGat[m.lnFieldF,1] = m.lcWholeWal
				laFieldGat[m.lnFieldF,1] = UPPER(ALLTRIM(laFieldGat[m.lnFieldF,1]))
				laFieldGat[m.lnFieldF,1] = CHRTRAN(laFieldGat[m.lnFieldF,1],CHRTRAN(laFieldGat[m.lnFieldF,1],"_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ",""),"")
				IF !ISALPHA(laFieldGat[m.lnFieldF,1])
					laFieldGat[m.lnFieldF,1] = "_" + laFieldGat[m.lnFieldF,1]
				ENDIF
				laFieldGat[m.lnFieldF,1] = LEFT(laFieldGat[m.lnFieldF,1],IIF(m.llCursor,31,10)) && 31
			OTHERWISE
				laFieldGat[m.lnFieldF,1] = m.lcWholeWal
				laFieldGat[m.lnFieldF,1] = UPPER(ALLTRIM(laFieldGat[m.lnFieldF,1]))
				laFieldGat[m.lnFieldF,1] = CHRTRAN(laFieldGat[m.lnFieldF,1],CHRTRAN(laFieldGat[m.lnFieldF,1],"_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ",""),"")
				IF !ISALPHA(laFieldGat[m.lnFieldF,1])
					laFieldGat[m.lnFieldF,1] = "_" + laFieldGat[m.lnFieldF,1]
				ENDIF
				laFieldGat[m.lnFieldF,1] = LEFT(laFieldGat[m.lnFieldF,1],IIF(m.llCursor,31,10)) && 31
			ENDCASE
			FOR lni = m.lnFieldF - m.lnSpan TO m.lnFieldF
				laFieldGat[m.lni,1] = laFieldGat[m.lnFieldF,1]
				lnName = 0
				lcName = laFieldGat[m.lni,1]
				DO WHILE BETWEEN(ASCAN(laFieldGat,m.lcName,1,-1,1,1+2+4+8), 1, m.lni - 1)
					lnName = m.lnName + 1
					lcName = laFieldGat[m.lni,1]
					lnLeftName = MIN(LEN(laFieldGat[m.lni,1]) , IIF(m.llCursor,31,10) - LEN(TRANSFORM(m.lnName))) && 31
					lcName = LEFT(laFieldGat[m.lni,1], m.lnLeftName) + TRANSFORM(m.lnName)
				ENDDO
				laFieldGat[m.lni,1] = m.lcName
			NEXT

			lnFieldF = m.lnFieldF + 1
			lnFieldExtr = m.lnFieldExtr + 1
			lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lnFieldExtr)
		ENDDO
		lnFieldF = m.lnFieldF - 1
	ENDIF




	lnCurRow = m.lnStartRows
	lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr ","</w:tr>",m.lnCurRow)
	IF EMPTY(m.lcWholeRow)
		RETURN ''
	ENDIF
	lnField = 1 
	lnFieldExtr = 1
	lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lnFieldExtr)
	DO WHILE !EMPTY(m.lcCell)
		lnSpan = 0
		lcSpan = STREXTRACT(m.lcCell,[w:gridSpan w:val="],["])
		IF !EMPTY(m.lcSpan)
			lnSpan = VAL(m.lcSpan) - 1
		ENDIF
		IF m.lnField + m.lnSpan > m.lnFieldF
			DIMENSION laFieldGat[m.lnField + m.lnSpan,18]
			FOR lni = m.lnField TO m.lnField + m.lnSpan
				STORE 0 TO laFieldGat[m.lni,17],laFieldGat[m.lni,18],laFieldGat[m.lni,4]
				STORE .T. TO laFieldGat[m.lni,5]
				STORE .F. TO laFieldGat[m.lni,6],laFieldGat[m.lni,5]
				STORE '' TO laFieldGat[m.lni,7],laFieldGat[m.lni,8],laFieldGat[m.lni,9],laFieldGat[m.lni,10],laFieldGat[m.lni,11],laFieldGat[m.lni,12],laFieldGat[m.lni,13],laFieldGat[m.lni,14],laFieldGat[m.lni,15],laFieldGat[m.lni,16]
				laFieldGat[m.lni,1] = "MFIELD"+TRANSFORM(m.lni)
				laFieldGat[m.lni,2] = "M"
				laFieldGat[m.lni,3] = 4
			NEXT
		ENDIF
		lnField = lnField + m.lnSpan
		lnPar = 1
		lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>])
		lcWholeWal = ""
		DO WHILE !EMPTY(m.lcPar)
			lcPar = STREXTRACT(m.lcPar,[>])
			lnPar = m.lnPar + 1
			
			lnTextPiece = 1
			lcVal = ""
			lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>]) 
			DO WHILE !EMPTY(m.lcTextPiece)
				lnTextPiece = m.lnTextPiece + 1
				IF INLIST(LEFT(m.lcTextPiece,1),' ','>')
					lcVal = m.lcVal + STREXTRACT(m.lcTextPiece,'>')
				ENDIF
				lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>],m.lnTextPiece) 
			ENDDO
			lcWholeWal = m.lcWholeWal + IIF(EMPTY(m.lcWholeWal),"",CHR(13)+CHR(10)) + m.lcVal
			lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>],m.lnPar)
		ENDDO
		llNumber = !EMPTY(m.lcWholeWal) and EMPTY(CHRTRAN(m.lcWholeWal,"0123456789+-" + m.lcPoint,"")) and ;
					OCCURS(m.lcPoint,m.lcWholeWal) < 2 and ;
					OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) < 2 and ;
					IIF(OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) > 0, LEFT(LTRIM(m.lcWholeWal),1) $ "+-", .T.) ;
					and AT(CHR(13),m.lcWholeWal) = 0
		llDate = !EMPTY(CTOD(m.lcWholeWal))
		llTime = !llDate and !EMPTY(CTOT(m.lcWholeWal))
		llBool = INLIST(LOWER(ALLTRIM(m.lcWholeWal)),m.lcTrue,m.lcFalse)
		IF m.lnFieldF < m.lnField
			laFieldGat[m.lnField,1] = "MFIELD"+TRANSFORM(m.lnField)
		ENDIF
		DO CASE
		CASE m.llNumber
			laFieldGat[m.lnField - m.lnSpan,2] = "B"
			laFieldGat[m.lnField - m.lnSpan,3] = 8
			laFieldGat[m.lnField - m.lnSpan,4] = 15
		CASE m.llDate
			laFieldGat[m.lnField - m.lnSpan,2] = "D"
			laFieldGat[m.lnField - m.lnSpan,3] = 8
		CASE m.llTime
			laFieldGat[m.lnField - m.lnSpan,2] = "T"
			laFieldGat[m.lnField - m.lnSpan,3] = 8
		CASE m.llBool
			laFieldGat[m.lnField - m.lnSpan,2] = "L"
			laFieldGat[m.lnField - m.lnSpan,3] = 1
		OTHERWISE
			laFieldGat[m.lnField - m.lnSpan,2] = "M"
			laFieldGat[m.lnField - m.lnSpan,3] = 4
		ENDCASE
		FOR lnj = m.lnField - m.lnSpan + 1 TO m.lnField
			laFieldGat[m.lnj,2] = "M"
			laFieldGat[m.lnj,3] = 4
		NEXT
		lnField = m.lnField + 1
		lnFieldExtr = m.lnFieldExtr + 1
		lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lnFieldExtr)
	ENDDO
	lnField = m.lnField - 1
	lnField = MAX(m.lnField,m.lnFieldF) 
	CREATE CURSOR (m.lcTable) FROM ARRAY laFieldGat
RETURN m.lcTable

*****************
* Read document *
*****************
FUNCTION get_cells
	LPARAMETERS lcStr,lnStartRows,lnTable,lnField,laField,cCur,lcFileName,lcTrue,lcFalse,llCursor
	LOCAL lcSetDec,lnCurRow,lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal,laFieldGat[1],laFieldPrec[m.lnField,2],lcPoint,lcTable,lcTextPiece,lnPar,lcPar,lcWholeWal
	LOCAL llNumber,llDate,llTime,llBool,lnSpan,lcSpan,lnFieldExtr,lnj
	lcSetDec = SET("Decimals")
	lcPoint = SET("Point")
	laFieldPrec = 0
	SET DECIMALS TO 10
	lcTable = FORCEEXT(m.lcFileName,"DBF")

	lcWholeDoc = FILETOSTR(m.lcStr)
	lnNoOfTables = OCCURS("<w:tbl>",m.lcWholeDoc)
	IF m.lnNoOfTables < m.lnTable
		MESSAGEBOX(ERRMESS3,16,ERRMESS0)
		RETURN ''
	ENDIF
	lcWholeTable = STREXTRACT(m.lcWholeDoc,"<w:tbl>","</w:tbl>",m.lnTable)
	lnCurRow = m.lnStartRows
	lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr","</w:tr>",m.lnCurRow)
	DO WHILE !EMPTY(m.lcWholeRow)
		lcWholeRow = STREXTRACT(m.lcWholeTable,"<w:tr ","</w:tr>",m.lnCurRow)
		IF EMPTY(m.lcWholeRow)
			EXIT
		ENDIF
		SELECT (m.cCur)
		APPEND BLANK
		SCATTER MEMO TO laFieldGat
		lni = 1
		lnFieldExtr = 1
		lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
		DO WHILE !EMPTY(m.lcCell) && m.lni <= m.lnField
*		FOR lni = 1 TO lnField
*			lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
			lnPar = 1
			lnSpan = 0
			lcSpan = STREXTRACT(m.lcCell,[w:gridSpan w:val="],["])
			IF !EMPTY(m.lcSpan)
				lnSpan = VAL(m.lcSpan) - 1
			ENDIF
			lnFieldExtr = m.lnFieldExtr + m.lnSpan
			lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>])
			lcWholeWal = ""
			DO WHILE !EMPTY(m.lcPar)
				lcPar = STREXTRACT(m.lcPar,[>])
				lnPar = m.lnPar + 1
				
				lnTextPiece = 1
				lcVal = ""
				lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>]) 
				DO WHILE !EMPTY(m.lcTextPiece)
					lnTextPiece = m.lnTextPiece + 1
					IF INLIST(LEFT(m.lcTextPiece,1),' ','>')
						lcVal = m.lcVal + STREXTRACT(m.lcTextPiece,'>')
					ENDIF
					lcTextPiece = STREXTRACT(m.lcPar,[<w:t],[</w:t>],m.lnTextPiece) 
				ENDDO

				lcWholeWal = m.lcWholeWal + IIF(EMPTY(m.lcWholeWal),"",CHR(13)+CHR(10)) + m.lcVal
				lcPar = STREXTRACT(m.lcCell,[<w:p ],[</w:p>],m.lnPar)
			ENDDO
			IF EMPTY(m.lcWholeWal)
				lni = m.lni + 1
				lnFieldExtr = m.lnFieldExtr + 1
				lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
				LOOP
			ENDIF
			IF m.lnFieldExtr > m.lnField
				DIMENSION laField[m.lnFieldExtr,18],laFieldPrec[m.lnFieldExtr,2],laFieldGat[m.lnFieldExtr]
				FOR lnj = m.lnFieldExtr - m.lnSpan TO m.lnFieldExtr
					STORE 0 TO laField[m.lnj,17],laField[m.lnj,18],laField[m.lnj,4]
					STORE .T. TO laField[m.lnj,5]
					STORE .F. TO laField[m.lnj,6],laField[m.lnj,5]
					STORE '' TO laField[m.lnj,7],laField[m.lnj,8],laField[m.lnj,9],laField[m.lnj,10],laField[m.lnj,11],laField[m.lnj,12],laField[m.lnj,13],laField[m.lnj,14],laField[m.lnj,15],laField[m.lnj,16]
					llNumber = !EMPTY(m.lcWholeWal) and EMPTY(CHRTRAN(m.lcWholeWal,"0123456789+-" + m.lcPoint,"")) and ;
								OCCURS(m.lcPoint,m.lcWholeWal) < 2 and ;
								OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) < 2 and ;
								IIF(OCCURS("+",m.lcWholeWal) + OCCURS("-",m.lcWholeWal) > 0, LEFT(LTRIM(m.lcWholeWal),1) $ "+-", .T.) ;
								and AT(CHR(13),m.lcWholeWal) = 0
					llDate = !EMPTY(CTOD(m.lcWholeWal))
					llTime = !llDate and !EMPTY(CTOT(m.lcWholeWal))
					llBool = INLIST(LOWER(ALLTRIM(m.lcWholeWal)),m.lcTrue,m.lcFalse)
					laField[m.lnj,1] = "MFIELD"+TRANSFORM(m.lnj)
					This.aField[m.lnj,2] = "M"
					This.aField[m.lnj,3] = 4
					IF m.lnj > m.lnFieldExtr - m.lnSpan
						ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lnj)) M
					ENDIF
				NEXT
				DO CASE
				CASE m.llNumber
					laField[m.lm.lnFieldExtr - m.lnSpan,2] = "B"
					laField[m.lm.lnFieldExtr - m.lnSpan,3] = 8
					laField[m.lm.lnFieldExtr - m.lnSpan,4] = 15
					ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lm.lnFieldExtr - m.lnSpan)) B(15)
				CASE m.llDate
					laField[m.lm.lnFieldExtr - m.lnSpan,2] = "D"
					laField[m.lm.lnFieldExtr - m.lnSpan,3] = 8
					ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lm.lnFieldExtr - m.lnSpan)) D
				CASE m.llTime
					laField[m.lm.lnFieldExtr - m.lnSpan,2] = "T"
					laField[m.lm.lnFieldExtr - m.lnSpan,3] = 8
					ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lm.lnFieldExtr - m.lnSpan)) T
				CASE m.llBool
					laField[m.lm.lnFieldExtr - m.lnSpan,2] = "L"
					laField[m.lm.lnFieldExtr - m.lnSpan,3] = 1
					ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lm.lnFieldExtr - m.lnSpan)) L
				OTHERWISE
					laField[m.lm.lnFieldExtr - m.lnSpan,2] = "M"
					laField[m.lm.lnFieldExtr - m.lnSpan,3] = 4
					ALTER table (m.cCur) ADD COLUMN ("MFIELD"+TRANSFORM(m.lm.lnFieldExtr - m.lnSpan)) M
				ENDCASE
				GO BOTTOM in (m.cCur)
				STORE 0 TO laFieldPrec[m.lm.lnFieldExtr - m.lnSpan,1],laFieldPrec[m.lm.lnFieldExtr - m.lnSpan,2]
				lnField = m.lnFieldExtr
			ENDIF
			IF laField[m.lnFieldExtr - m.lnSpan,2] == "M"
				laFieldGat[m.lnFieldExtr - m.lnSpan] = htmspec(m.lcWholeWal)
				laFieldPrec[m.lnFieldExtr - m.lnSpan,1] = MAX(laFieldPrec[m.lnFieldExtr - m.lnSpan,1],LEN(laFieldGat[m.lnFieldExtr - m.lnSpan]))
				laFieldPrec[m.lnFieldExtr - m.lnSpan,2] = MAX(laFieldPrec[m.lnFieldExtr - m.lnSpan,2],OCCURS(CHR(13),laFieldGat[m.lnFieldExtr - m.lnSpan]))
			ELSE
				IF laField[m.lnFieldExtr - m.lnSpan,2] == "B"
					laFieldGat[m.lnFieldExtr - m.lnSpan] = VAL(m.lcWholeWal)
					laFieldPrec[m.lnFieldExtr - m.lnSpan,1] = MAX(laFieldPrec[m.lnFieldExtr - m.lnSpan,1],LEN(ALLTRIM(m.lcWholeWal)))
					IF AT(m.lcPoint,ALLTRIM(m.lcWholeWal)) > 0 
						laFieldPrec[m.lnFieldExtr - m.lnSpan,2] = MAX(laFieldPrec[m.lnFieldExtr - m.lnSpan,2],LEN(ALLTRIM(m.lcWholeWal)) - AT(m.lcPoint,ALLTRIM(m.lcWholeWal)))
					ENDIF
				ELSE
					IF laField[m.lnFieldExtr - m.lnSpan,2] $ "D"
						laFieldGat[m.lnFieldExtr - m.lnSpan] = CTOD(m.lcWholeWal)
					ELSE
						IF laField[m.lnFieldExtr - m.lnSpan,2] $ "T"
							laFieldGat[m.lnFieldExtr - m.lnSpan] = CTOT(m.lcWholeWal)
						ELSE
							IF laField[m.lnFieldExtr - m.lnSpan,2] $ "L"
								laFieldGat[m.lnFieldExtr - m.lnSpan] = LOWER(m.lcWholeWal) == m.lcTrue
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			lni = m.lni + 1
			lnFieldExtr = m.lnFieldExtr + 1
			lcCell = STREXTRACT(m.lcWholeRow,[<w:tc>],[</w:tc>],m.lni)
		ENDDO
*		NEXT
		SELECT (m.cCur)
		GATHER FROM laFieldGat MEMO
		lnCurRow = m.lnCurRow + 1
	ENDDO
	SET DECIMALS TO &lcSetDec
	lcSql = "LPARAMETERS lcTable" + CHR(13) + "SELECT "
	FOR lni = 1 TO lnField
		IF laField[m.lni,2] == "M" AND BETWEEN(laFieldPrec[m.lni,1],1,254) AND laFieldPrec[m.lni,2] = 0
			lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS C(" + TRANSFORM(laFieldPrec[m.lni,1]) + ")) AS " + laField[m.lni,1] + ","
		ELSE
			IF laField[m.lni,2] == "B" AND BETWEEN(laFieldPrec[m.lni,1],1,20)
				IF laFieldPrec[m.lni,2] = 0 AND BETWEEN(laFieldPrec[m.lni,1],1,9)
					lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS I) AS " + laField[m.lni,1] + ","
				ELSE
					lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS N(" + TRANSFORM(laFieldPrec[m.lni,1]) + "," + TRANSFORM(laFieldPrec[m.lni,2]) + ")) AS " + laField[m.lni,1] + ","
				ENDIF
			ELSE
				lcSql = m.lcSql + laField[m.lni,1] + ","
			ENDIF
		ENDIF
	NEXT
	IF m.llCursor
		lcTable = SYS(2015) && CHRTRAN(JUSTSTEM(m.lcTable)," ","_")
		lcSql = RTRIM(m.lcSql,1,",") + " FROM " + m.cCur + " INTO CURSOR (m.lcTable) READWRITE"
		EXECSCRIPT(m.lcSql,m.lcTable)
	ELSE
		lcSql = RTRIM(m.lcSql,1,",") + " FROM " + m.cCur + " INTO TABLE (m.lcTable)" + CHR(13) + "RETURN ALIAS()"
		USE IN (EXECSCRIPT(m.lcSql,m.lcTable))
	ENDIF
	USE IN (m.cCur)
RETURN m.lcTable

**********************
* Special characters *
**********************
FUNCTION htmspec
	LPARAMETERS cStr
	LOCAL lni,lcStrF,lcChar,lnChar
	lcStrF = m.cStr
	IF AT('&gt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&gt;','>')
	ENDIF
	IF AT('&lt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&lt;','<')
	ENDIF
	IF AT('&quot;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&quot;','"')
	ENDIF
	IF AT("&apos;",m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&apos;',"'")
	ENDIF
	IF AT([&#],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#]+STR(m.lnChar,3)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT([&#x],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#x]+RIGHT(TRANSFORM(m.lnChar,"@0"),2)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT('&amp;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&amp;',CHR(38))
	ENDIF

    * suggested by Koen Piller
	lcStrF = STRCONV(m.lcStrF,11)
	RETURN m.lcStrF
ENDFUNC

*****************
* Cleanup
******************
FUNCTION cleanup
	LPARAMETERS lcDir
	LOCAL lcZip,lcSetSaf
	lcZip = FORCEEXT(m.lcDir,'zip')
	lcSetSaf = SET("Safety")
	SET SAFETY OFF
	TRY 
		ERASE (ADDBS(m.lcDir)+'*.*')
		RD (m.lcDir)
	CATCH TO m.loErr
	ENDTRY

	ERASE (m.lcZip)
	SET SAFETY &lcSetSaf
RETURN .T.
